void serial_init(char *port, int baud);

void serial_set_timeout (int mseconds);

/* write out all output bytes and wait for them to finish transmitting. */
void serial_sync ();
/* read in any pending input bytes.  */
void serial_drain ();

void serial_write(unsigned char ch);
void serial_write_block(unsigned char *ch, int len);
void serial_write_string(char *ch);

/* returns -1 for timeout, else 0..255 */
int serial_read(void);
