typedef void (*rxs_func)() __attribute__((mode(SI)));
typedef void (*rx_func)(unsigned char) __attribute__((mode(SI)));

typedef struct {
  rxs_func command_rx_start;
  rx_func command_rx;
  rxs_func command_tx_start;
  unsigned char *tx_buffer;
  unsigned int tx_count;
} i2c_setup_struct;

/* command_tx_start sets these */
extern void *i2c_tx_buffer;
extern int i2c_tx_count;
