.include "r8c-ports.S"

	.section ".und", "a"
	und
	und
	und

	.section ".vec", "a"
	.3byte	_undefined_insn_handler	; UND
	.byte	0xff
	.3byte	0	; overflow
	.byte	0xff
	.3byte	_brk_insn_handler	; BRK, see also ivect
	.byte	0xff

	.section ".resetvec", "a"
	.global	_reset
_reset:
	.3byte	_start
	.byte	0xff		; watchdog settings.

	.text
	.global _start
_start:
	fclr	I
	fclr	U	/* Interrupt stack gets the big main stack.  */
	ldc	#__stack,sp
; We're going to use a combined stack, because we're running low on memory.
;	fset	U	/* User stack gets the little one. */
;	ldc	#__istack,sp

	ldc	#%lo16(irq_vector),intbl
	ldc	#%hi16(irq_vector),intbh

; Copy ROM data to RAM
	mov.b	#%hi8(__romdatastart),r1h
	mov.w	#%lo16(__romdatastart),a0
	mov.w	#__datastart,a1
	mov.w	#__romdatacopysize,r3
	shl.w	#-1,r3
	smovf.w

	mov.w	#__bssstart,a1
	mov.w	#__bsssize,r3
	shl.w	#-1,r3
	mov.w	#0,r0
	sstr.w

; Now fire up the fast clock

	mov.b	#0x01, prcr
	mov.b	#0x08, cm0
	mov.b	#0x38, cm1
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	mov.b	#0x00, ocd
	mov.b	#0x08, cm0
	fset	I

; Run the main application

	jmp.w	_main

	.bss
	.global	mem0
mem0:	.space	1
	.global	mem1
mem1:	.space	1
	.global	mem2
mem2:	.space	1
	.global	mem3
mem3:	.space	1
	.global	mem4
mem4:	.space	1
	.global	mem5
mem5:	.space	1
	.global	mem6
mem6:	.space	1
	.global	mem7
mem7:	.space	1
	.global	mem8
mem8:	.space	1
	.global	mem9
mem9:	.space	1
	.global	mem10
mem10:	.space	1
	.global	mem11
mem11:	.space	1
	.global	mem12
mem12:	.space	1
	.global	mem13
mem13:	.space	1
	.global	mem14
mem14:	.space	1
	.global	mem15
mem15:	.space	1

