typedef unsigned char byte;

typedef union {
  struct {
    byte b0:1;
    byte b1:1;
    byte b2:1;
    byte b3:1;
    byte b4:1;
    byte b5:1;
    byte b6:1;
    byte b7:1;
  };
  byte byte;
} BytePort;

#define pd0 (*(volatile byte *)0xe2)
#define pd1 (*(volatile byte *)0xe3)
#define pd3 (*(volatile byte *)0xe7)
#define pd4 (*(volatile byte *)0xea)
#define p0 (*(volatile byte *)0xe0)
#define p1 (*(volatile byte *)0xe1)
#define p3 (*(volatile byte *)0xe5)
#define p4 (*(volatile byte *)0xe8)

#define drr (*(volatile byte *)0xfe)
extern volatile byte drr, prcr, cm0, cm1, ocd;

extern volatile union {
  struct {
    byte cks:4;
    byte trs:1;
    byte mst:1;
    byte rcvd:1;
    byte ice:1;
  };
  byte b;
} iccr1;

extern volatile union {
} u0mr, u1mr;
